VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCRC32"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private lngCRC32Table() As Long

Public Sub Class_Initialize()
    ReDim lngCRC32Table(256)

    lngCRC32Table(0) = &H0
    lngCRC32Table(1) = &H4C11DB7
    lngCRC32Table(2) = &H9823B6E
    lngCRC32Table(3) = &HD4326D9
    lngCRC32Table(4) = &H130476DC
    lngCRC32Table(5) = &H17C56B6B
    lngCRC32Table(6) = &H1A864DB2
    lngCRC32Table(7) = &H1E475005
    lngCRC32Table(8) = &H2608EDB8
    lngCRC32Table(9) = &H22C9F00F
    lngCRC32Table(10) = &H2F8AD6D6
    lngCRC32Table(11) = &H2B4BCB61
    lngCRC32Table(12) = &H350C9B64
    lngCRC32Table(13) = &H31CD86D3
    lngCRC32Table(14) = &H3C8EA00A
    lngCRC32Table(15) = &H384FBDBD
    lngCRC32Table(16) = &H4C11DB70
    lngCRC32Table(17) = &H48D0C6C7
    lngCRC32Table(18) = &H4593E01E
    lngCRC32Table(19) = &H4152FDA9
    lngCRC32Table(20) = &H5F15ADAC
    lngCRC32Table(21) = &H5BD4B01B
    lngCRC32Table(22) = &H569796C2
    lngCRC32Table(23) = &H52568B75
    lngCRC32Table(24) = &H6A1936C8
    lngCRC32Table(25) = &H6ED82B7F
    lngCRC32Table(26) = &H639B0DA6
    lngCRC32Table(27) = &H675A1011
    lngCRC32Table(28) = &H791D4014
    lngCRC32Table(29) = &H7DDC5DA3
    lngCRC32Table(30) = &H709F7B7A
    lngCRC32Table(31) = &H745E66CD
    lngCRC32Table(32) = &H9823B6E0
    lngCRC32Table(33) = &H9CE2AB57
    lngCRC32Table(34) = &H91A18D8E
    lngCRC32Table(35) = &H95609039
    lngCRC32Table(36) = &H8B27C03C
    lngCRC32Table(37) = &H8FE6DD8B
    lngCRC32Table(38) = &H82A5FB52
    lngCRC32Table(39) = &H8664E6E5
    lngCRC32Table(40) = &HBE2B5B58
    lngCRC32Table(41) = &HBAEA46EF
    lngCRC32Table(42) = &HB7A96036
    lngCRC32Table(43) = &HB3687D81
    lngCRC32Table(44) = &HAD2F2D84
    lngCRC32Table(45) = &HA9EE3033
    lngCRC32Table(46) = &HA4AD16EA
    lngCRC32Table(47) = &HA06C0B5D
    lngCRC32Table(48) = &HD4326D90
    lngCRC32Table(49) = &HD0F37027
    lngCRC32Table(50) = &HDDB056FE
    lngCRC32Table(51) = &HD9714B49
    lngCRC32Table(52) = &HC7361B4C
    lngCRC32Table(53) = &HC3F706FB
    lngCRC32Table(54) = &HCEB42022
    lngCRC32Table(55) = &HCA753D95
    lngCRC32Table(56) = &HF23A8028
    lngCRC32Table(57) = &HF6FB9D9F
    lngCRC32Table(58) = &HFBB8BB46
    lngCRC32Table(59) = &HFF79A6F1
    lngCRC32Table(60) = &HE13EF6F4
    lngCRC32Table(61) = &HE5FFEB43
    lngCRC32Table(62) = &HE8BCCD9A
    lngCRC32Table(63) = &HEC7DD02D
    lngCRC32Table(64) = &H34867077
    lngCRC32Table(65) = &H30476DC0
    lngCRC32Table(66) = &H3D044B19
    lngCRC32Table(67) = &H39C556AE
    lngCRC32Table(68) = &H278206AB
    lngCRC32Table(69) = &H23431B1C
    lngCRC32Table(70) = &H2E003DC5
    lngCRC32Table(71) = &H2AC12072
    lngCRC32Table(72) = &H128E9DCF
    lngCRC32Table(73) = &H164F8078
    lngCRC32Table(74) = &H1B0CA6A1
    lngCRC32Table(75) = &H1FCDBB16
    lngCRC32Table(76) = &H18AEB13
    lngCRC32Table(77) = &H54BF6A4
    lngCRC32Table(78) = &H808D07D
    lngCRC32Table(79) = &HCC9CDCA
    lngCRC32Table(80) = &H7897AB07
    lngCRC32Table(81) = &H7C56B6B0
    lngCRC32Table(82) = &H71159069
    lngCRC32Table(83) = &H75D48DDE
    lngCRC32Table(84) = &H6B93DDDB
    lngCRC32Table(85) = &H6F52C06C
    lngCRC32Table(86) = &H6211E6B5
    lngCRC32Table(87) = &H66D0FB02
    lngCRC32Table(88) = &H5E9F46BF
    lngCRC32Table(89) = &H5A5E5B08
    lngCRC32Table(90) = &H571D7DD1
    lngCRC32Table(91) = &H53DC6066
    lngCRC32Table(92) = &H4D9B3063
    lngCRC32Table(93) = &H495A2DD4
    lngCRC32Table(94) = &H44190B0D
    lngCRC32Table(95) = &H40D816BA
    lngCRC32Table(96) = &HACA5C697
    lngCRC32Table(97) = &HA864DB20
    lngCRC32Table(98) = &HA527FDF9
    lngCRC32Table(99) = &HA1E6E04E
    lngCRC32Table(100) = &HBFA1B04B
    lngCRC32Table(101) = &HBB60ADFC
    lngCRC32Table(102) = &HB6238B25
    lngCRC32Table(103) = &HB2E29692
    lngCRC32Table(104) = &H8AAD2B2F
    lngCRC32Table(105) = &H8E6C3698
    lngCRC32Table(106) = &H832F1041
    lngCRC32Table(107) = &H87EE0DF6
    lngCRC32Table(108) = &H99A95DF3
    lngCRC32Table(109) = &H9D684044
    lngCRC32Table(110) = &H902B669D
    lngCRC32Table(111) = &H94EA7B2A
    lngCRC32Table(112) = &HE0B41DE7
    lngCRC32Table(113) = &HE4750050
    lngCRC32Table(114) = &HE9362689
    lngCRC32Table(115) = &HEDF73B3E
    lngCRC32Table(116) = &HF3B06B3B
    lngCRC32Table(117) = &HF771768C
    lngCRC32Table(118) = &HFA325055
    lngCRC32Table(119) = &HFEF34DE2
    lngCRC32Table(120) = &HC6BCF05F
    lngCRC32Table(121) = &HC27DEDE8
    lngCRC32Table(122) = &HCF3ECB31
    lngCRC32Table(123) = &HCBFFD686
    lngCRC32Table(124) = &HD5B88683
    lngCRC32Table(125) = &HD1799B34
    lngCRC32Table(126) = &HDC3ABDED
    lngCRC32Table(127) = &HD8FBA05A
    lngCRC32Table(128) = &H690CE0EE
    lngCRC32Table(129) = &H6DCDFD59
    lngCRC32Table(130) = &H608EDB80
    lngCRC32Table(131) = &H644FC637
    lngCRC32Table(132) = &H7A089632
    lngCRC32Table(133) = &H7EC98B85
    lngCRC32Table(134) = &H738AAD5C
    lngCRC32Table(135) = &H774BB0EB
    lngCRC32Table(136) = &H4F040D56
    lngCRC32Table(137) = &H4BC510E1
    lngCRC32Table(138) = &H46863638
    lngCRC32Table(139) = &H42472B8F
    lngCRC32Table(140) = &H5C007B8A
    lngCRC32Table(141) = &H58C1663D
    lngCRC32Table(142) = &H558240E4
    lngCRC32Table(143) = &H51435D53
    lngCRC32Table(144) = &H251D3B9E
    lngCRC32Table(145) = &H21DC2629
    lngCRC32Table(146) = &H2C9F00F0
    lngCRC32Table(147) = &H285E1D47
    lngCRC32Table(148) = &H36194D42
    lngCRC32Table(149) = &H32D850F5
    lngCRC32Table(150) = &H3F9B762C
    lngCRC32Table(151) = &H3B5A6B9B
    lngCRC32Table(152) = &H315D626
    lngCRC32Table(153) = &H7D4CB91
    lngCRC32Table(154) = &HA97ED48
    lngCRC32Table(155) = &HE56F0FF
    lngCRC32Table(156) = &H1011A0FA
    lngCRC32Table(157) = &H14D0BD4D
    lngCRC32Table(158) = &H19939B94
    lngCRC32Table(159) = &H1D528623
    lngCRC32Table(160) = &HF12F560E
    lngCRC32Table(161) = &HF5EE4BB9
    lngCRC32Table(162) = &HF8AD6D60
    lngCRC32Table(163) = &HFC6C70D7
    lngCRC32Table(164) = &HE22B20D2
    lngCRC32Table(165) = &HE6EA3D65
    lngCRC32Table(166) = &HEBA91BBC
    lngCRC32Table(167) = &HEF68060B
    lngCRC32Table(168) = &HD727BBB6
    lngCRC32Table(169) = &HD3E6A601
    lngCRC32Table(170) = &HDEA580D8
    lngCRC32Table(171) = &HDA649D6F
    lngCRC32Table(172) = &HC423CD6A
    lngCRC32Table(173) = &HC0E2D0DD
    lngCRC32Table(174) = &HCDA1F604
    lngCRC32Table(175) = &HC960EBB3
    lngCRC32Table(176) = &HBD3E8D7E
    lngCRC32Table(177) = &HB9FF90C9
    lngCRC32Table(178) = &HB4BCB610
    lngCRC32Table(179) = &HB07DABA7
    lngCRC32Table(180) = &HAE3AFBA2
    lngCRC32Table(181) = &HAAFBE615
    lngCRC32Table(182) = &HA7B8C0CC
    lngCRC32Table(183) = &HA379DD7B
    lngCRC32Table(184) = &H9B3660C6
    lngCRC32Table(185) = &H9FF77D71
    lngCRC32Table(186) = &H92B45BA8
    lngCRC32Table(187) = &H9675461F
    lngCRC32Table(188) = &H8832161A
    lngCRC32Table(189) = &H8CF30BAD
    lngCRC32Table(190) = &H81B02D74
    lngCRC32Table(191) = &H857130C3
    lngCRC32Table(192) = &H5D8A9099
    lngCRC32Table(193) = &H594B8D2E
    lngCRC32Table(194) = &H5408ABF7
    lngCRC32Table(195) = &H50C9B640
    lngCRC32Table(196) = &H4E8EE645
    lngCRC32Table(197) = &H4A4FFBF2
    lngCRC32Table(198) = &H470CDD2B
    lngCRC32Table(199) = &H43CDC09C
    lngCRC32Table(200) = &H7B827D21
    lngCRC32Table(201) = &H7F436096
    lngCRC32Table(202) = &H7200464F
    lngCRC32Table(203) = &H76C15BF8
    lngCRC32Table(204) = &H68860BFD
    lngCRC32Table(205) = &H6C47164A
    lngCRC32Table(206) = &H61043093
    lngCRC32Table(207) = &H65C52D24
    lngCRC32Table(208) = &H119B4BE9
    lngCRC32Table(209) = &H155A565E
    lngCRC32Table(210) = &H18197087
    lngCRC32Table(211) = &H1CD86D30
    lngCRC32Table(212) = &H29F3D35
    lngCRC32Table(213) = &H65E2082
    lngCRC32Table(214) = &HB1D065B
    lngCRC32Table(215) = &HFDC1BEC
    lngCRC32Table(216) = &H3793A651
    lngCRC32Table(217) = &H3352BBE6
    lngCRC32Table(218) = &H3E119D3F
    lngCRC32Table(219) = &H3AD08088
    lngCRC32Table(220) = &H2497D08D
    lngCRC32Table(221) = &H2056CD3A
    lngCRC32Table(222) = &H2D15EBE3
    lngCRC32Table(223) = &H29D4F654
    lngCRC32Table(224) = &HC5A92679
    lngCRC32Table(225) = &HC1683BCE
    lngCRC32Table(226) = &HCC2B1D17
    lngCRC32Table(227) = &HC8EA00A0
    lngCRC32Table(228) = &HD6AD50A5
    lngCRC32Table(229) = &HD26C4D12
    lngCRC32Table(230) = &HDF2F6BCB
    lngCRC32Table(231) = &HDBEE767C
    lngCRC32Table(232) = &HE3A1CBC1
    lngCRC32Table(233) = &HE760D676
    lngCRC32Table(234) = &HEA23F0AF
    lngCRC32Table(235) = &HEEE2ED18
    lngCRC32Table(236) = &HF0A5BD1D
    lngCRC32Table(237) = &HF464A0AA
    lngCRC32Table(238) = &HF9278673
    lngCRC32Table(239) = &HFDE69BC4
    lngCRC32Table(240) = &H89B8FD09
    lngCRC32Table(241) = &H8D79E0BE
    lngCRC32Table(242) = &H803AC667
    lngCRC32Table(243) = &H84FBDBD0
    lngCRC32Table(244) = &H9ABC8BD5
    lngCRC32Table(245) = &H9E7D9662
    lngCRC32Table(246) = &H933EB0BB
    lngCRC32Table(247) = &H97FFAD0C
    lngCRC32Table(248) = &HAFB010B1
    lngCRC32Table(249) = &HAB710D06
    lngCRC32Table(250) = &HA6322BDF
    lngCRC32Table(251) = &HA2F33668
    lngCRC32Table(252) = &HBCB4666D
    lngCRC32Table(253) = &HB8757BDA
    lngCRC32Table(254) = &HB5365D03
    lngCRC32Table(255) = &HB1F740B4
End Sub

Public Function GetCRC32(strIn As String) As Long
    Dim lngCRC32Result As Long, lngCount As Long
    lngCRC32Result = &H0
    For lngCount = 0 To Len(strIn) - 1
        lngCRC32Result = RShift(lngCRC32Result, 8) Xor lngCRC32Table((LShift(lngCRC32Result, 24) And &HFF) Xor Asc(Mid(strIn, lngCount + 1, 1)))
    Next
    GetCRC32 = lngCRC32Result
End Function

Private Function LShift(lngThis As Long, bytBits As Byte) As Long
    If (bytBits > 31) Then
       LShift = 0
    Else
       If (lngThis And &H80000000) = &H80000000 Then
          LShift = (lngThis And &H7FFFFFFF) \ (2 ^ bytBits) Or (2 ^ (31 - bytBits))
       Else
          LShift = lngThis \ (2 ^ bytBits)
       End If
    End If
End Function

Private Function RShift(lngThis As Long, bytBits As Byte) As Long
    If (bytBits > 31) Then
       RShift = 0
    Else
       If (lngThis And (2 ^ (31 - bytBits))) = (2 ^ (31 - bytBits)) Then
          RShift = (lngThis And ((2 ^ (31 - bytBits)) - 1)) * (2 ^ bytBits) Or &H80000000
       Else
          RShift = (lngThis And ((2 ^ (31 - bytBits)) - 1)) * (2 ^ bytBits)
       End If
    End If
End Function

